﻿using Newtonsoft.Json;
using Syncfusion.EJ.PdfViewer;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web;
using System.Web.Http;

namespace ASPPDFDemo
{
    public class PdfViewerController : ApiController
    {
        public object Load(Dictionary<string, string> jsonResult)
        {
            PdfViewerHelper helper = new PdfViewerHelper();
            //load the multiple document from client side 
           if (jsonResult.ContainsKey("newFileName"))
            {
                var name = jsonResult["newFileName"];
                var pdfName = name.ToString();
                helper.Load(Helper.GetFilePath("" + name));
            }
            else
            {
                if (jsonResult.ContainsKey("isInitialLoading"))
                {
                    if (jsonResult.ContainsKey("file"))
                    {
                        var name = jsonResult["file"];
                        helper.Load(name);
                    }
                    else
                    {
                        helper.Load(Helper.GetFilePath("F# Succinctly.pdf"));
                        PdfLoadedDocument ldoc = new PdfLoadedDocument(Helper.GetFilePath("F# Succinctly.pdf"));
                        string extractedText = string.Empty;
                        foreach (PdfLoadedPage page in ldoc.Pages)
                        {
                            extractedText += page.ExtractText(true);
                        }

                        using (System.IO.StreamWriter file = new System.IO.StreamWriter(Helper.GetFilePath("F# Succinctly.txt")))
                        {
                            file.WriteLine(extractedText);
                        }
                        Dictionary<int, List<RectangleF>> matches = new Dictionary<int, List<RectangleF>>();
                        ldoc.FindText("To see the advantages of functional programming, you must look at what FP permits rather than", out matches);
                    }
                }
            }
            string output = JsonConvert.SerializeObject(helper.ProcessPdf(jsonResult));
            return output;
        }
        public object FileUpload(Dictionary<string, string> jsonResult)
        {
            PdfViewerHelper helper = new PdfViewerHelper();

            if (jsonResult.ContainsKey("uploadedFile"))
            {
                var fileurl = jsonResult["uploadedFile"];
                byte[] byteArray = Convert.FromBase64String(fileurl);
                MemoryStream stream = new MemoryStream(byteArray);
                helper.Load(stream);
            }
            string output = JsonConvert.SerializeObject(helper.ProcessPdf(jsonResult));
            return output;
        }
        public object Download(Dictionary<string, string> jsonResult)
        {
            PdfViewerHelper helper = new PdfViewerHelper();
            if (jsonResult.ContainsKey("savedFields"))
            {
                var values = jsonResult["savedFields"];
                Dictionary<string, string> data = JsonConvert.DeserializeObject<Dictionary<string, string>>(values);
                jsonResult = data;
            }
            return (helper.GetDocumentData(jsonResult));
        }
    }

    public class Helper
    {
        public static string GetFilePath(string path)
        {
            string _dataPath = GetCommonFolder(new DirectoryInfo(HttpContext.Current.Request.PhysicalApplicationPath));
            _dataPath += @"\" + path;
            return _dataPath;
        }

        static string GetCommonFolder(DirectoryInfo dtInfo)
        {
            var _folderNames = dtInfo.GetDirectories("Data");
            if (_folderNames.Length > 0)
            {
                return _folderNames[0].FullName;
            }

            return dtInfo.Parent != null ? GetCommonFolder(dtInfo.Parent) : string.Empty;
        }
    }
}